# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Api.Member do
  @moduledoc """
  API calls for all endpoints tagged `Member`.
  """

  alias FoyerAPI.Connection
  import FoyerAPI.RequestBuilder


  @doc """
  Delete Member by Id
  Delete specific Member with unique Id

  ## Parameters

  - connection (FoyerAPI.Connection): Connection to server
  - id (integer()): 
  - opts (KeywordList): [optional] Optional parameters
  ## Returns

  {:ok, nil} on success
  {:error, Tesla.Env.t} on failure
  """
  @spec delete_member_by_id(Tesla.Env.client, integer(), keyword()) :: {:ok, nil} | {:error, Tesla.Env.t}
  def delete_member_by_id(connection, id, _opts \\ []) do
    %{}
    |> method(:delete)
    |> url("/Member/#{id}")
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 204, false},
      { 401, false}
    ])
  end

  @doc """
  Find One Member
  Fine one Member according to defined filter criteria

  ## Parameters

  - connection (FoyerAPI.Connection): Connection to server
  - filter (String.t): 
  - opts (KeywordList): [optional] Optional parameters
  ## Returns

  {:ok, FoyerAPI.Model.Member.t} on success
  {:error, Tesla.Env.t} on failure
  """
  @spec find_one_member(Tesla.Env.client, String.t, keyword()) :: {:ok, nil} | {:ok, FoyerAPI.Model.Member.t} | {:error, Tesla.Env.t}
  def find_one_member(connection, filter, _opts \\ []) do
    %{}
    |> method(:get)
    |> url("/Member/findOne")
    |> add_param(:headers, :filter, filter)
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 200, %FoyerAPI.Model.Member{}},
      { 401, false}
    ])
  end

  @doc """
  Get Member by Id
  Get specific Member with unique Id

  ## Parameters

  - connection (FoyerAPI.Connection): Connection to server
  - id (integer()): 
  - opts (KeywordList): [optional] Optional parameters
    - :filter (String.t): 
  ## Returns

  {:ok, FoyerAPI.Model.Member.t} on success
  {:error, Tesla.Env.t} on failure
  """
  @spec get_member_by_id(Tesla.Env.client, integer(), keyword()) :: {:ok, nil} | {:ok, FoyerAPI.Model.Member.t} | {:error, Tesla.Env.t}
  def get_member_by_id(connection, id, opts \\ []) do
    optional_params = %{
      :filter => :headers
    }
    %{}
    |> method(:get)
    |> url("/Member/#{id}")
    |> add_optional_params(optional_params, opts)
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 200, %FoyerAPI.Model.Member{}},
      { 401, false}
    ])
  end

  @doc """
  Patch Member by Id
  Patch specific Member with unique Id

  ## Parameters

  - connection (FoyerAPI.Connection): Connection to server
  - id (integer()): 
  - opts (KeywordList): [optional] Optional parameters
    - :body ([FoyerAPI.Model.PatchDocument.t]): 
  ## Returns

  {:ok, FoyerAPI.Model.Member.t} on success
  {:error, Tesla.Env.t} on failure
  """
  @spec patch_member_by_id(Tesla.Env.client, integer(), keyword()) :: {:ok, nil} | {:ok, FoyerAPI.Model.Member.t} | {:error, Tesla.Env.t}
  def patch_member_by_id(connection, id, opts \\ []) do
    optional_params = %{
      :body => :body
    }
    %{}
    |> method(:patch)
    |> url("/Member/#{id}")
    |> add_optional_params(optional_params, opts)
    |> ensure_body()
    |> Enum.into([])
    |> (&Connection.request(connection, &1)).()
    |> evaluate_response([
      { 200, %FoyerAPI.Model.Member{}},
      { 401, false}
    ])
  end
end
